import { HomebridgeServiceHelper } from '../hb-service';
export declare class DarwinInstaller {
    private hbService;
    private user;
    constructor(hbService: HomebridgeServiceHelper);
    private get plistName();
    private get plistPath();
    install(): Promise<void>;
    uninstall(): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
    restart(): Promise<void>;
    rebuild(all?: boolean): Promise<void>;
    getId(): Promise<{
        uid: number;
        gid: number;
    }>;
    getPidOfPort(port: number): string;
    private checkForRoot;
    private fixStoragePath;
    getUserHomeDir(): string;
    updateNodejs(job: {
        target: string;
        rebuild: boolean;
    }): Promise<void>;
    private checkGlobalNpmAccess;
    private setNpmPermissions;
    private createLaunchAgent;
}
