import { ServerService } from './server.service';
import { HomebridgeMdnsSettingDto, HomebridgeNetworkInterfacesDto } from './server.dto';
export declare class ServerController {
    private serverService;
    constructor(serverService: ServerService);
    restartServer(): Promise<{
        ok: boolean;
        command: string;
        restartingUI: boolean;
    }>;
    restartChildBridge(deviceId: string): Promise<{
        ok: boolean;
    }>;
    getBridgePairingInformation(): Promise<import("@nestjs/common").ServiceUnavailableException | {
        displayName: any;
        pincode: any;
        setupCode: string;
        isPaired: boolean;
    }>;
    getQrCode(): Promise<any>;
    resetHomebridgeAccessory(): Promise<void>;
    resetCachedAccessories(): Promise<void>;
    getCachedAccessories(): Promise<any[]>;
    deleteCachedAccessory(uuid: string, cacheFile?: string): Promise<unknown>;
    getDevicePairings(): Promise<any[]>;
    getDevicePairingById(deviceId: string): Promise<any>;
    deleteDevicePairing(deviceId: string): Promise<void>;
    lookupUnusedPort(): Promise<{
        port: number;
    }>;
    getSystemNetworkInterfaces(): Promise<import("systeminformation").Systeminformation.NetworkInterfacesData[]>;
    getHomebridgeNetworkInterfaces(): Promise<string[]>;
    setHomebridgeNetworkInterfaces(body: HomebridgeNetworkInterfacesDto): Promise<void>;
    getHomebridgeMdnsSetting(): Promise<HomebridgeMdnsSettingDto>;
    setHomebridgeMdnsSetting(body: HomebridgeMdnsSettingDto): Promise<void>;
}
