import { StatusService } from './status.service';
export declare class StatusController {
    private readonly statusService;
    constructor(statusService: StatusService);
    getServerCpuInfo(): Promise<{
        cpuTemperature: {
            main: number;
            cores: any[];
            max: number;
        };
        currentLoad: number;
        cpuLoadHistory: number[];
    }>;
    getServerMemoryInfo(): Promise<{
        mem: import("systeminformation").Systeminformation.MemData;
        memoryUsageHistory: number[];
    }>;
    getServerUptimeInfo(): Promise<{
        time: import("systeminformation").Systeminformation.TimeData;
        processUptime: number;
    }>;
    checkHomebridgeStatus(): Promise<{
        status: "down" | "up";
    }>;
    getHomebridgeVersion(): Promise<import("../plugins/types").HomebridgePlugin>;
    getHomebridgeServerInfo(): Promise<{
        serviceUser: string;
        homebridgeConfigJsonPath: string;
        homebridgeStoragePath: string;
        homebridgeInsecureMode: boolean;
        homebridgeCustomPluginPath: string;
        homebridgeRunningInDocker: boolean;
        homebridgeServiceMode: boolean;
        nodeVersion: string;
        os: import("systeminformation").Systeminformation.OsData;
        time: import("systeminformation").Systeminformation.TimeData;
        network: {};
    }>;
    getNodeJsVersionInfo(): Promise<unknown>;
}
