const qs = require('qs')
const fastify = require('fastify')({
  querystri_ngParser: str => qs.parse(str)
})

fastify.addHook('preValidation', (request, reply, done) => {
  console.log(request.query)
  request.query.location = JSON.parse(request.query.location)
  done()
})

fastify.get('/', {
  schema: {
    querystring: {
      location: {
        type: 'object',
        properties: {
          find: { type: 'string', enum: ['near', 'far'] }
        }
      }
    }
  },
  handler (req, res) {
    console.log('pinged!!')
    res.send(req.query)
  }
})

fastify.listen(8080)
